/*
* Numer dowodu osobistego
* orginalnie Tomasz Lubinski
* - poprawki z wykorzystaniem metody string.indexOf javascript R. ya
* www.algorytm.org
*/

/*
* Sprawdza czy podany numer Dowodu Osobitego jest prawidowy
* @param {string} numer - seria i numer Dowodu Osobitego do walidacji (bez spacji, myslinkow, itp)
* @return {boolean} - zwraca true jeeli podany numer jest prawidowy, false w przeciwnym wypadku
*/
function validateDO(numer)
{
//Check length
  if (numer == null || numer.length != 9)
    return false;

  numer = numer.toUpperCase();
  letterValues = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  function getLetterValue(letter){
	return letterValues.indexOf(letter)
  }
 
//Check seria
for (i=0; i<3; i++)
  if (getLetterValue(numer[i]) < 10 || numer[i] == 'O' || numer == 'Q')
    return false;
//Check numbers
for (i=3; i<9; i++)
  if (getLetterValue(numer[i]) < 0 || getLetterValue(numer[i]) > 9)
return false;
 
//sprawdz cyfre kontrolna
  sum = 7 * getLetterValue(numer[0]) +
	3 * getLetterValue(numer[1]) +
	1 * getLetterValue(numer[2]) +
	7 * getLetterValue(numer[4]) +
	3 * getLetterValue(numer[5]) +
	1 * getLetterValue(numer[6]) +
	7 * getLetterValue(numer[7]) +
	3 * getLetterValue(numer[8]);
	sum %= 10;
	if (sum != getLetterValue(numer[3]))
return false;
 
return true;
}
 
/**
* Sprawdza czy podany numer Dowodu Osobitego jest prawidowy
* @param {string} numer - seria i numer Dowodu Osobitego do walidacji (spacja lub mylnik oddziela seri od numeru)
* @return {boolean} - zwraca true jeeli podany numer jest prawidowy, false w przeciwnym wypadku
*/
function validateDOwithSeparator(numer)
{
//Check length
if (numer == null || numer.length != 10)
return false;

//Check separator
if (numer[3] != ' ' && numer[3] != '-')
return false;

numer = numer.replace(/[\s-]/g, '');
return validateDO(numer);
}

/*
* Sprawdza czy podany numer Dowodu Osobistego jest prawidowy
* @param {string} seria - seria Dowodu Osobistego do walidacji
* @param {string} numer - numer Dowodu Osobistego do walidacji
* @return {boolean} - zwraca true jeeli podany numer jest prawidowy, false w przeciwnym wypadku
* @return {boolean} - zwraca take false jeli w serii jest uyta litera O lub Q
*/
function validateDO2(seria, numer)
{
return validateDO(seria + numer);
}
